// Simple Key Search Protocol Client
// (c) Andy Brown 1995


#ifndef __CLDOC_H
#define __CLDOC_H

#include "prjarray.h"
#include "srvarray.h"


class CClientDoc : public CDocument
{
protected: // create from serialization only
	CClientDoc();
	DECLARE_DYNCREATE(CClientDoc)

// Attributes
public:
  CString m_Email;
  CString m_Name;
  CProjectArray m_Projects;
  CServerArray m_Servers;

// Operations
public:
  void Read(void);
  void Write(void);

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CClientDoc)
	public:
	virtual BOOL OnNewDocument();
	virtual BOOL CanCloseFrame(CFrameWnd* pFrame);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CClientDoc();
	virtual void Serialize(CArchive& ar);   // overridden for document i/o
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CClientDoc)
	afx_msg void OnFileProperties();
	afx_msg void OnUpdateOptionsSearches(CCmdUI* pCmdUI);
	afx_msg void OnOptionsSearches();
	afx_msg void OnHelpIndex();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};


#endif

