// Simple Key Search Protocol Client
// (c) Andy Brown 1995


#include "stdafx.h"
#include "SKSPclnt.h"
#include "startdlg.h"


#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif


/****************/
/* Construction */
/****************/

CStartSearchDlg::CStartSearchDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CStartSearchDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CStartSearchDlg)
	m_Parameters = _T("");
	m_Priority = -1;
	m_Time = _T("");
	m_Type = _T("");
	//}}AFX_DATA_INIT
}


/*************************/
/* Dynamic data exchange */
/*************************/

void CStartSearchDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CStartSearchDlg)
	DDX_Text(pDX, IDC_PARAMETERS, m_Parameters);
	DDX_CBIndex(pDX, IDC_PRIORITY, m_Priority);
	DDX_Text(pDX, IDC_TIME, m_Time);
	DDX_Text(pDX, IDC_TYPE, m_Type);
	//}}AFX_DATA_MAP
}


/***************/
/* Message map */
/***************/

BEGIN_MESSAGE_MAP(CStartSearchDlg, CDialog)
	//{{AFX_MSG_MAP(CStartSearchDlg)
	ON_BN_CLICKED(IDC_RECALIBRATE, OnRecalibrate)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/**************************/
/* Recalibrate the search */
/**************************

works out the # of keys per/sec that this machine will do */

void CStartSearchDlg::OnRecalibrate() 
{
  UpdateData(TRUE);
  m_Time=MYAPP->m_Search.GetTime(m_Parameters,m_Type,MYAPP->m_Search.Recalibrate(m_Type));
  UpdateData(FALSE);
}
